% compute the cost matrix

function [cost] = link_cost(param, mean_move)

% dist max = cutogff
max_val = 100;


nb_region1 = length(param{1});
nb_region2 = length(param{2});

cost1 = inf(nb_region1,nb_region2);
cost2 = eye(nb_region2);
cost3 = eye(nb_region1);


for n=1:nb_region1
    
    for m=1:nb_region2
       
        
        [weight] = cost_weight(param,n,m, mean_move);
        
        
        if weight < max_val
            
            cost1(n,m) = weight;

        end
        
    end
    
end

ma = unique(cost1(:));

cost2 = cost2 .* (1.05*ma(end-1));
cost3 = cost3 .* (1.05*ma(end-1));

cost2(cost2==0)=inf;
cost3(cost3==0)=inf;

cost = [cost1 cost3 ; cost2 cost1'];
cost = munkres(cost);



 
function [w] = cost_weight(param,n,m, mean_move)

        dist_max = 25;
        darea_max = 150;
        x_dist_fac = 0.5;
        y_dist_fac = 5;
        long_fac = 1.7;
        angle_fac = 2.5;

        centr1 =  param{1}(n).center;
        centr2 =  param{2}(m).center;
        area1 =  param{1}(n).boundedarea;
        area2=  param{2}(m).boundedarea;
        long1 = param{1}(n).longueur;
        long2 = param{2}(m).longueur;
        angl1 = param{1}(n).slope;
        angl2 = param{2}(m).slope;
        % compute the distance between 2 points
        % compute the distance between 2 points
        dellong = abs(long2-long1)/(long2+long1);
        dist = sqrt(sum(diff([centr1;centr2]).^2));
        distx = diff([centr2(1); centr1(1)]);
        if distx < -3
            distx = 50*abs(distx);
        else
            distx = abs(distx);
        end
        disty = abs(diff([centr1(2); centr2(2)]));
%         darea(n,m) = abs(area2-area1);
%         sumarea(n,m) = area2+area1;
        darea_ratio = abs(area2-area1)/(area2+area1);
        dangle = Delta_Angle(angl1, angl2);
        % compute the distance between 2 points
        if mean_move > 6 && centr1(1) < 300
            distx = diff([centr2(1); centr1(1)]);
            if distx < mean_move
                distx = 50*abs(distx);
            else
                distx = abs(distx);
            end
        end
        if dist < dist_max && ((dellong < 0.17 && mean([long1 long2]) < 40) ||  (dellong < 0.15 && mean([long1 long2]) >= 40))
            w = dist+distx*x_dist_fac + disty*y_dist_fac+darea_ratio*3+dellong*long_fac + dangle*angle_fac;
        else
           
            
            w = inf;
            
        end
end
end

% centr1 =  param{1}(n).center;
%         centr2 =  param{2}(m).center;
%         
%        if dist(n,m) < dist_max && darea_ratio(n,m) < 0.15
%             
%             cost1(n,m) = dist(n,m)+darea_ratio(n,m)*10;
%         end
% 



