function [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit] = myprofileline( middle_point, opposite_middle_point)
%myprofileline : This function retrieves the x and y values along a line defined by the 2 extremities



slope = (opposite_middle_point(1)-middle_point(1))/(opposite_middle_point(2)-middle_point(2));

length_profile = ceil(sqrt((opposite_middle_point(1)-middle_point(1))^2+(opposite_middle_point(2)-middle_point(2))^2));
deltax = opposite_middle_point(2)-middle_point(2);
deltaxunit = deltax/length_profile;
sigx = sign(deltax);
deltay = (opposite_middle_point(1)-middle_point(1));
deltayunit = deltay/length_profile;
sigy = sign(deltay);
if deltaxunit == 0;
    xprofile = ones(floor(length_profile+1),1)*middle_point(2);
else
    xprofile = middle_point(2):deltaxunit:opposite_middle_point(2);%+deltaxunit;
% else
%     xprofile = [middle_point(2):deltaxunit:opposite_middle_point(2) opposite_middle_point(2)];
%     
end
if deltayunit == 0
    yprofile = ones(1,length_profile+1)*middle_point(1);
else
    yprofile = middle_point(1):deltayunit:opposite_middle_point(1);%+deltayunit;
% else
%     yprofile = [middle_point(1):deltayunit:opposite_middle_point(1) opposite_middle_point(1)];
end

% if deltax-floor(deltax) > 0.5 && deltay-floor(deltay) > 0.5
%     Rounding = 'ceil';
% elseif deltax-floor(deltax) < 0.5 && deltay-floor(deltay) < 0.5
%     Rounding = 'floor';
%     
end
%               
% 
% deltax2 = middle_point(2)-opposite_middle_point(2);
% deltay2 = middle_point(1)-opposite_middle_point(1);
% deltaxunit2 = deltax2/length_profile;
% sigx = sign(deltax2);
% deltayunit2 = deltay2/length_profile;
% sigy = sign(deltay2);
% 
% 
% xprofile2 = [opposite_middle_point(2):deltaxunit2:middle_point(2) middle_point(2)];
% yprofile2 = [opposite_middle_point(1):deltayunit2:middle_point(1) middle_point(1)];
% 
% 
% [middle_point(1) yprofile opposite_middle_point(1); middle_point(1) yprofile2(end:-1:1)  opposite_middle_point(1)]